/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.exec.service.exec.utils;

import org.apache.axis.message.addressing.EndpointReferenceType;
import org.globus.exec.service.exec.ManagedExecutableJobResource;
import org.globus.rft.generated.RFTFaultResourcePropertyType;
import org.globus.rft.generated.BaseRequestType;
import org.globus.rft.generated.RequestStatusType;
import org.globus.rft.generated.StartOutputType;
import org.oasis.wsrf.faults.BaseFaultType;
import org.globus.exec.service.exec.StateMachine;

public abstract class StagingHelper
{
    public BaseFaultType getTransferFaultFromRP(
        RFTFaultResourcePropertyType        faultRP)
    {
        if (faultRP == null) {
            return null;
        }

        if(faultRP.getRftAuthenticationFaultType() != null) {
            return faultRP.getRftAuthenticationFaultType();
        } else if(faultRP.getRftAuthorizationFaultType() != null) {
            return faultRP.getRftAuthorizationFaultType();
        } else if(faultRP.getRftDatabaseFaultType() != null) {
            return faultRP.getRftDatabaseFaultType();
        } else if(faultRP.getRftRepeatedlyStartedFaultType() != null) {
            return faultRP.getRftRepeatedlyStartedFaultType();
        } else if(faultRP.getRftTransferFaultType() != null) {
            return faultRP.getRftTransferFaultType();
        } else if(faultRP.getTransferTransientFaultType() != null) {
            return faultRP.getTransferTransientFaultType();
        } else {
            return null;
        }
    }

    abstract public EndpointReferenceType submitStagingRequest(
        ManagedExecutableJobResource        resource,
        BaseRequestType                     stagingRequest)
        throws                              Exception;

    abstract public StartOutputType startTransferJob(
        ManagedExecutableJobResource            resource,
        EndpointReferenceType                   transferJobEndpoint)
        throws                                  Exception;

    abstract public void destroyTransferJob(
        ManagedExecutableJobResource        resource,
        EndpointReferenceType               transferJobEndpoint)
        throws                              Exception;

    abstract public RequestStatusType poll(
        ManagedExecutableJobResource        resource,
        EndpointReferenceType               transferJobEndpoint);


    protected String getLoggingPrefix(
        ManagedExecutableJobResource        resource)
    {
        return StateMachine.getLoggingPrefix(resource);
    }
}
