/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.exec.service.factory;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.globus.exec.utils.Resources;
import org.globus.util.I18n;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class FactoryHomeConfiguration
{
    private static Log logger =
        LogFactory.getLog(FactoryHomeConfiguration.class);

    static I18n i18n = I18n.getI18n(Resources.class.getName());

    public FactoryHomeConfiguration() {
    }

    /**
     * Names are separated by the space character.
     * @return String
     *
    public String getLocalResourceManagerNames() {
        return this.localResourceManagers;
    }

    public void setLocalResourceManagerNames(String localResourceManagers) {
        this.localResourceManagers = localResourceManagers;
    }*/

    public String getGlobusLocation() {
        return this.globusLocation;
    }

    public void setGlobusLocation(String globusLocation) {
        this.globusLocation = globusLocation;
    }

    public String getX509CertDir() {
        return this.x509CertDir;
    }

    public void setX509CertDir(String x509CertDir) {
        this.x509CertDir = x509CertDir;
    }

    public String getHostOsName() {
        return this.hostOsName;
    }

    public void setHostOsName(String os) {
        this.hostOsName = os;
    }

    public String getHostOsVersion() {
        return this.hostOsVersion;
    }

    public void setHostOsVersion(String os) {
        this.hostOsVersion = os;
    }

    public String getHostCpuType() {
        return this.hostCpuType;
    }

    public void setHostCpuType(String cpuType) {
        this.hostCpuType = cpuType;
    }

    public String getHostManufacturer() {
        return this.hostManufacturer;
    }

    public void setHostManufacturer(String hostManufacturer) {
        this.hostManufacturer = hostManufacturer;
    }

    public String getCondorArchitecture() {
        return this.condorArchitecture;
    }

    public void setCondorArchitecture(String condorArchitecture) {
        this.condorArchitecture = condorArchitecture;
    }

    public String getCondorOS() {
        return this.condorOS;
    }

    public void setCondorOS(String condorOS) {
        this.condorOS = condorOS;
    }

    public String getTcpPortRange() {
        return this.tcpPortRange;
    }

    public void setTcpPortRange(String tcpPortRange) {
        this.tcpPortRange = tcpPortRange;
    }

    public String getStagingProtocol() {
        return this.stagingProtocol;
    }

    public void setStagingProtocol(String stagingProtocol)
    {
        if (stagingProtocol.length() > 0)
        {
            this.stagingProtocol = stagingProtocol;
        }
    }

    public String getStagingHost() {
        return this.stagingHost;
    }

    public void setStagingHost(String stagingHost)
    {
        if (stagingHost.length() > 0)
        {
            this.stagingHost = stagingHost;
        }
    }

    public String getStagingPort() {
        return this.stagingPort;
    }

    public void setStagingPort(String stagingPort)
    {
        if (stagingPort.length() > 0)
        {
            this.stagingPort = stagingPort;
        }
    }

    public String getStagingServicePath() {
        return this.stagingServicePath;
    }

    public void setStagingServicePath(String stagingServicePath)
    {
        if (stagingServicePath.length() > 0)
        {
            this.stagingServicePath = stagingServicePath;
        }
    }

    public String getStagingFactoryName() {
        return this.stagingFactoryName;
    }

    public void setStagingFactoryName(String stagingFactoryName)
    {
        if (stagingFactoryName.length() > 0)
        {
            this.stagingFactoryName = stagingFactoryName;
        }
    }

    public String getStagingDelegationFactoryName() {
        return this.stagingDelegationFactoryName;
    }

    public void setStagingDelegationFactoryName(
        String                              stagingDelegationFactoryName)
    {
        if (stagingDelegationFactoryName.length() > 0)
        {
            this.stagingDelegationFactoryName = stagingDelegationFactoryName;
        }
    }

    public String getStagingSubject() {
        return this.stagingSubject;
    }

    public void setStagingSubject(String stagingSubject)
    {
        if (stagingSubject.length() > 0)
        {
            this.stagingSubject = stagingSubject;
        }
    }

    public String getRunQueueThreadCount() {
        return this.runQueueThreadCount;
    }

    public void setRunQueueThreadCount(String runQueueThreadCount) {
        this.runQueueThreadCount = runQueueThreadCount;
    }

    public String getEnableLocalInvocations() {
        return this.enableLocalInvocations;
    }
    
    public void setEnableLocalInvocations(String enableLocalInvocations) {
        this.enableLocalInvocations = enableLocalInvocations;
    }

    public String getMaxUnsubmittedJobCount() {
        return this.maxUnsubmittedJobCount;
    }

    public void setMaxUnsubmittedJobCount(String maxUnsubmittedJobCount) {
        if (!maxUnsubmittedJobCount.equals("-1"))
        {
            logger.warn(i18n.getMessage(
                Resources.CONFIGURATION_PARAMETER_CHANGED_FROM_DEFAULT,
                "maxUnsubmittedJobCount"));
        }

        this.maxUnsubmittedJobCount = maxUnsubmittedJobCount;
    }

    public String getMaxPendingRequestCount() {
        return this.maxPendingRequestCount;
    }

    public void setMaxPendingRequestCount(String maxPendingRequestCount) {
        if (!maxPendingRequestCount.equals("-1"))
        {
            logger.warn(i18n.getMessage(
                Resources.CONFIGURATION_PARAMETER_CHANGED_FROM_DEFAULT,
                "maxPendingRequestCount"));
        }

        this.maxPendingRequestCount = maxPendingRequestCount;
    }

    public String getMaxSubmissionRetryCount() {
        return this.maxSubmissionRetryCount;
    }

    public void setMaxSubmissionRetryCount(String maxSubmissionRetryCount) {
        if (!maxSubmissionRetryCount.equals("-1"))
        {
            logger.warn(i18n.getMessage(
                Resources.CONFIGURATION_PARAMETER_CHANGED_FROM_DEFAULT,
                "maxSubmissionRetryCount"));
        }

        this.maxSubmissionRetryCount = maxSubmissionRetryCount;
    }

    public String getSubmissionRetryDelay() {
        return this.submissionRetryDelay;
    }

    public void setSubmissionRetryDelay(String submissionRetryDelay) {
        if (!submissionRetryDelay.equals("-1"))
        {
            logger.warn(i18n.getMessage(
                Resources.CONFIGURATION_PARAMETER_CHANGED_FROM_DEFAULT,
                "submissionRetryDelay"));
        }

        this.submissionRetryDelay = submissionRetryDelay;
    }

    /**
     * Values common to all Factory Resources.
     */
    private String globusLocation;
    private String x509CertDir;
    private String hostOsName;
    private String hostCpuType;
    private String hostManufacturer;
    private String hostOsVersion;
    private String condorArchitecture;
    private String condorOS;
    private String tcpPortRange;
    private String stagingProtocol = null;
    private String stagingHost = null;
    private String stagingPort = null;
    private String stagingServicePath = null;
    private String stagingFactoryName = null;
    private String stagingDelegationFactoryName = null;
    private String stagingSubject;
    private String enableLocalInvocations;
    private String runQueueThreadCount;
    private String maxUnsubmittedJobCount;
    private String maxPendingRequestCount;
    private String maxSubmissionRetryCount;
    private String submissionRetryDelay;

    /**
     * List of local resource managers (for instance Fork, LSF, PBS, etc...)
     * that the Factory Home will create Factory Resources for.
     *
    private String localResourceManagers;*/

}
