/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.exec.service.factory;


public class FactoryResourceConfiguration
{
    /**
     * local resource manager (for instance Fork, LSF, PBS, etc...)
     * that the Factory Resource will create jobs for.
     */
    private String localResourceManager;
    private String scratchDirectory;
    private String substitutionDefinitionsFile;
    private String substitutionDefinitionsRefreshPeriod;
    private String enableDefaultSoftwareEnvironment;

    public FactoryResourceConfiguration() {
        /* Default value of scratchDir */
        this.scratchDirectory = "${GLOBUS_USER_HOME}/.globus/scratch";
    }

    public String getLocalResourceManagerName() {
        return this.localResourceManager;
    }

    public void setLocalResourceManagerName(String localResourceManager) {
        this.localResourceManager = localResourceManager;
    }

    public String getScratchDirectory() {
        return this.scratchDirectory;
    }

    public void setScratchDirectory(
        String                              scratchDirectory)
    {
        this.scratchDirectory = scratchDirectory;
    }

    public String getSubstitutionDefinitionsFile() {
        return this.substitutionDefinitionsFile;
    }

    public void setSubstitutionDefinitionsFile(
        String                              substitutionDefinitionsFile)
    {
        this.substitutionDefinitionsFile = substitutionDefinitionsFile;
    }

    public String getSubstitutionDefinitionsRefreshPeriod() {
        return this.substitutionDefinitionsRefreshPeriod;
    }

    public void setSubstitutionDefinitionsRefreshPeriod(
        String                          substitutionDefinitionsRefreshPeriod)
    {
        this.substitutionDefinitionsRefreshPeriod
            = substitutionDefinitionsRefreshPeriod;
    }

    public String getEnableDefaultSoftwareEnvironment() {
        return this.enableDefaultSoftwareEnvironment;
    }

    public void setEnableDefaultSoftwareEnvironment(
        String                          enableDefaultSoftwareEnvironment)
    {
        this.enableDefaultSoftwareEnvironment
            = enableDefaultSoftwareEnvironment;
    }
}
