/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.exec.service.job;

import java.util.Calendar;

import org.globus.exec.generated.JobDescriptionType;
import org.globus.wsrf.ResourceHome;
import org.globus.wsrf.ResourceKey;

public interface ManagedJobHome extends ResourceHome {

    public ResourceKey create(
            Calendar                    initialTerminationTime,
            Calendar                    currentTime,
            String                      localResourceManager,
            JobDescriptionType          jobDescription,
            String                      userSubject,
            String                      localUserId,
            String                      jobID,
            String                      serviceURL)
            throws                      Exception;

    /**
     * This function is useful in order to determine if the resource should
     * be stored.
     * @return boolean
     */
    public boolean isResourcePersistent();

    /**
     * This function returns the number of resources created by the
     * particular home instance.
     */
    public int getResourceCount();
}
