/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.exec.service.job;

import org.globus.wsrf.Resource;
import org.globus.wsrf.ResourceProperties;
import org.globus.wsrf.ResourceIdentifier;
import org.globus.wsrf.TopicListAccessor;
import org.globus.wsrf.ResourceException;

import javax.xml.namespace.QName;

import org.globus.exec.generated.ManagedJobResourceDataType;
import org.globus.exec.generated.StateEnumeration;

public interface ManagedJobResource extends Resource,
                                            ResourceProperties,
                                            ResourceIdentifier
{

    /**
     * Initialize the whole state of the resource. Called by the Home or
     * the persistence layer.<p>
     * The implementation must call initialize().
     *
     * @param wholeResourceState Object serializable type instance created
     *                           either by the Home or the persistence layer
     * @param resourcePropertiesQName QName
     * @param resourceKey Object
     * @throws ResourceException
     */
    public void   initializeWholeState(
    Object                                  wholeResourceState,
    QName                                   resourcePropertiesQName,
    Object                                  resourceKey)
    throws                                  ResourceException;

    public Object getResourceDatum(String datumName);
    public void   setResourceDatum(String name, Object value);

    public ManagedJobResourceDataType getResourceData();
    public void setResourceData(ManagedJobResourceDataType resourceData);

    public void   start();

    public StateEnumeration getState();
    public void setState(StateEnumeration state) throws Exception;
}
